package com.ejie.ab79.dao.preguntasRespuestas;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.inspecciones.Inspecciones;
import com.ejie.ab79.model.preguntasRespuestas.PreguntasExpediente;
import com.ejie.ab79.model.preguntasRespuestas.RespuestasExpediente;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableManagerJerarquia;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * RespuestasExpedienteDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class RespuestasExpedienteDaoImpl implements RespuestasExpedienteDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDRESPUESTAEXPEDIENTE", "IDPREGUNTAEXPEDIENTE",
			"RESPUESTA", "FECHAREGISTRO", "USUARIOREGISTRO", "FECHAULTMODIFICACION", "USUARIOULTMODIFICACION" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<RespuestasExpediente> rwMap = new RowMapper<RespuestasExpediente>() {
		@Override
		public RespuestasExpediente mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			PreguntasExpediente preguntaExpediente = new PreguntasExpediente();
			preguntaExpediente.setIdPreguntaExpediente(resultSet.getInt("IDPREGUNTAEXPEDIENTE"));

			return new RespuestasExpediente(resultSet.getInt("IDRESPUESTAEXPEDIENTE"), preguntaExpediente,
					resultSet.getString("RESPUESTA"), resultSet.getDate("FECHAREGISTRO"),
					resultSet.getString("USUARIOREGISTRO"), resultSet.getDate("FECHAULTMODIFICACION"),
					resultSet.getString("USUARIOULTMODIFICACION"), resultSet.getString("OBSERVACIONESINSPECCIONCAS"),
					resultSet.getString("OBSERVACIONESINSPECCIONEUS"));
		}
	};

	private RowMapper<RespuestasExpediente> rwMapPK = new RowMapper<RespuestasExpediente>() {
		@Override
		public RespuestasExpediente mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new RespuestasExpediente(resultSet.getInt("ID_RESPUESTA_EXPEDIENTE"));
		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<RespuestasExpediente>> rwMapJerarquia = new RowMapper<JerarquiaDto<RespuestasExpediente>>() {
		@Override
		public JerarquiaDto<RespuestasExpediente> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			PreguntasExpediente preguntaExpediente = new PreguntasExpediente();
			preguntaExpediente.setIdPreguntaExpediente(resultSet.getInt("IDPREGUNTAEXPEDIENTE"));
			RespuestasExpediente respuestasexpediente = new RespuestasExpediente(
					resultSet.getInt("IDRESPUESTAEXPEDIENTE"), preguntaExpediente, resultSet.getString("RESPUESTA"),
					resultSet.getDate("FECHAREGISTRO"), resultSet.getString("USUARIOREGISTRO"),
					resultSet.getDate("FECHAULTMODIFICACION"), resultSet.getString("USUARIOULTMODIFICACION"),
					resultSet.getString("OBSERVACIONESINSPECCIONCAS"),
					resultSet.getString("OBSERVACIONESINSPECCIONEUS"));

			JerarquiaDto<RespuestasExpediente> jerarquia = new JerarquiaDto<RespuestasExpediente>();
			jerarquia.setModel(respuestasexpediente);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the RespuestasExpediente table.
	 *
	 * @param respuestasexpediente
	 *            RespuestasExpediente
	 * @return RespuestasExpediente
	 */
	@Override
	public RespuestasExpediente add(RespuestasExpediente respuestasexpediente) {

		int idRespuestaExpediente = this.jdbcTemplate.queryForObject("SELECT AB79.S_AB7913T00.NEXTVAL FROM DUAL",
				Integer.class);
		respuestasexpediente.setIdRespuestaExpediente(idRespuestaExpediente);

		String query = "INSERT INTO RESPUESTAS_EXPEDIENTE (ID_RESPUESTA_EXPEDIENTE, ID_PREGUNTA_EXPEDIENTE, RESPUESTA, FECHA_REGISTRO, USUARIO_REGISTRO, NOTAS_INSPECTOR_CAS, NOTAS_INSPECTOR_EUS) VALUES (?,?,?,sysdate,?,?,?)";
		this.jdbcTemplate.update(query, respuestasexpediente.getIdRespuestaExpediente(),
				respuestasexpediente.getPreguntaExpediente() != null
						? respuestasexpediente.getPreguntaExpediente().getIdPreguntaExpediente() : null,
				respuestasexpediente.getRespuesta(), respuestasexpediente.getUsuarioRegistro(),
				respuestasexpediente.getObservacionesInspeccionCas(),
				respuestasexpediente.getObservacionesInspeccionEus());
		return respuestasexpediente;
	}

	/**
	 * Updates a single row in the RespuestasExpediente table.
	 *
	 * @param respuestasexpediente
	 *            RespuestasExpediente
	 * @return RespuestasExpediente
	 */
	@Override
	public RespuestasExpediente update(RespuestasExpediente respuestasexpediente) {
		String query = "UPDATE RESPUESTAS_EXPEDIENTE SET ID_PREGUNTA_EXPEDIENTE=?, RESPUESTA=?, FECHA_ULTMODIFICACION=sysdate, USUARIO_ULTMODIFICACION=?, NOTAS_INSPECTOR_CAS=?, NOTAS_INSPECTOR_EUS=? WHERE ID_RESPUESTA_EXPEDIENTE=?";
		this.jdbcTemplate.update(query,
				respuestasexpediente.getPreguntaExpediente() != null
						? respuestasexpediente.getPreguntaExpediente().getIdPreguntaExpediente() : null,
				respuestasexpediente.getRespuesta(), respuestasexpediente.getUsuarioUltmodificacion(),
				respuestasexpediente.getObservacionesInspeccionCas(),
				respuestasexpediente.getObservacionesInspeccionEus(), respuestasexpediente.getIdRespuestaExpediente());
		return respuestasexpediente;
	}

	@Override
	public RespuestasExpediente updateRespuesta(RespuestasExpediente respValAux) {
		StringBuilder query = new StringBuilder(
				"UPDATE RESPUESTAS_EXPEDIENTE SET RESPUESTA=?, FECHA_ULTMODIFICACION=sysdate, USUARIO_ULTMODIFICACION=?");
		query.append(", NOTAS_INSPECTOR_CAS=?, NOTAS_INSPECTOR_EUS=?");
		query.append(" WHERE ID_PREGUNTA_EXPEDIENTE=?");
		this.jdbcTemplate.update(query.toString(), respValAux.getRespuesta(), respValAux.getUsuarioUltmodificacion(),
				respValAux.getObservacionesInspeccionCas(), respValAux.getObservacionesInspeccionEus(),
				respValAux.getPreguntaExpediente() != null
						? respValAux.getPreguntaExpediente().getIdPreguntaExpediente() : null);
		return respValAux;
	}

	/**
	 * Finds a single row in the RespuestasExpediente table.
	 *
	 * @param respuestasexpediente
	 *            RespuestasExpediente
	 * @return RespuestasExpediente
	 */
	@Override
	@Transactional(readOnly = true)
	public RespuestasExpediente find(RespuestasExpediente respuestasexpediente) {
		String query = "SELECT t1.ID_RESPUESTA_EXPEDIENTE IDRESPUESTAEXPEDIENTE, t1.ID_PREGUNTA_EXPEDIENTE IDPREGUNTAEXPEDIENTE, t1.RESPUESTA RESPUESTA, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION, t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION, t1.NOTAS_INSPECTOR_CAS OBSERVACIONESINSPECCIONCAS, t1.NOTAS_INSPECTOR_EUS OBSERVACIONESINSPECCIONEUS FROM RESPUESTAS_EXPEDIENTE t1  WHERE t1.ID_RESPUESTA_EXPEDIENTE = ?  ";

		List<RespuestasExpediente> respuestasexpedienteList = this.jdbcTemplate.query(query, this.rwMap,
				respuestasexpediente.getIdRespuestaExpediente());
		return DataAccessUtils.uniqueResult(respuestasexpedienteList);
	}

	@Override
	public RespuestasExpediente findByIdPregunta(RespuestasExpediente respuestasExpediente) {
		String query = "SELECT t1.ID_RESPUESTA_EXPEDIENTE IDRESPUESTAEXPEDIENTE, t1.ID_PREGUNTA_EXPEDIENTE IDPREGUNTAEXPEDIENTE, t1.RESPUESTA RESPUESTA, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION, t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION, t1.NOTAS_INSPECTOR_CAS OBSERVACIONESINSPECCIONCAS, t1.NOTAS_INSPECTOR_EUS OBSERVACIONESINSPECCIONEUS FROM RESPUESTAS_EXPEDIENTE t1  WHERE t1.ID_PREGUNTA_EXPEDIENTE = ?  ";

		List<RespuestasExpediente> respuestasexpedienteList = this.jdbcTemplate.query(query, this.rwMap,
				respuestasExpediente.getPreguntaExpediente() != null
						? respuestasExpediente.getPreguntaExpediente().getIdPreguntaExpediente() : null);
		return DataAccessUtils.uniqueResult(respuestasexpedienteList);
	}

	@Override
	public RespuestasExpediente findByInspeccionYPregunta(Inspecciones inspeccion,
			PreguntasExpediente preguntaExpediente) {
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_RESPUESTA_EXPEDIENTE IDRESPUESTAEXPEDIENTE, t1.ID_PREGUNTA_EXPEDIENTE IDPREGUNTAEXPEDIENTE, t1.RESPUESTA RESPUESTA, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION, t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION, t1.NOTAS_INSPECTOR_CAS OBSERVACIONESINSPECCIONCAS, t1.NOTAS_INSPECTOR_EUS OBSERVACIONESINSPECCIONEUS FROM RESPUESTAS_EXPEDIENTE t1, PREGUNTAS_EXPEDIENTE t2 WHERE t2.ID_INSPECCION = ? AND t1.ID_PREGUNTA_EXPEDIENTE = t2.ID_PREGUNTA_EXPEDIENTE ");

		List<Object> params = new ArrayList<Object>();
		params.add(inspeccion.getIdInspeccion());

		if (preguntaExpediente != null && preguntaExpediente.getIdPreguntaExpediente() != null) {
			query.append(" AND t2.ID_PREGUNTA_EXPEDIENTE = ?");
			params.add(preguntaExpediente.getIdPreguntaExpediente());
		} else if (preguntaExpediente != null && preguntaExpediente.getIdPreguntaMovil() != null) {
			query.append(" AND t2.ID_PREGUNTA_MOVIL = ?");
			params.add(preguntaExpediente.getIdPreguntaMovil());
		}

		List<RespuestasExpediente> respuestasExpedienteList = this.jdbcTemplate.query(query.toString(), this.rwMap,
				params.toArray());
		return DataAccessUtils.uniqueResult(respuestasExpedienteList);
	}

	/**
	 * Removes a single row in the RespuestasExpediente table.
	 *
	 * @param respuestasexpediente
	 *            RespuestasExpediente
	 * @return
	 */
	@Override
	public void remove(RespuestasExpediente respuestasexpediente) {
		String query = "DELETE FROM RESPUESTAS_EXPEDIENTE WHERE ID_RESPUESTA_EXPEDIENTE=?";
		this.jdbcTemplate.update(query, respuestasexpediente.getIdRespuestaExpediente());
	}

	@Override
	public void removeByIdPreguntaExpediente(PreguntasExpediente preguntaExpediente) {
		String query = "DELETE FROM RESPUESTAS_EXPEDIENTE WHERE ID_PREGUNTA_EXPEDIENTE = ?";
		this.jdbcTemplate.update(query, preguntaExpediente.getIdPreguntaExpediente());
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	@Override
	public List<RespuestasExpediente> getMultiple(RespuestasExpediente filterRespuestasExpediente,
			TableRequestDto tableRequestDto, Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterRespuestasExpediente, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, RespuestasExpediente.class,
				params, "ID_RESPUESTA_EXPEDIENTE");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds a list of rows in the RespuestasExpediente table.
	 *
	 * @param respuestasexpediente
	 *            RespuestasExpediente
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<RespuestasExpediente>
	 */
	@Override
	@Transactional(readOnly = true)
	public List<RespuestasExpediente> findAll(RespuestasExpediente respuestasexpediente,
			TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_RESPUESTA_EXPEDIENTE IDRESPUESTAEXPEDIENTE, t1.ID_PREGUNTA_EXPEDIENTE IDPREGUNTAEXPEDIENTE,t1.RESPUESTA RESPUESTA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION, t1.NOTAS_INSPECTOR_CAS OBSERVACIONESINSPECCIONCAS, t1.NOTAS_INSPECTOR_EUS OBSERVACIONESINSPECCIONEUS ");
		query.append("FROM RESPUESTAS_EXPEDIENTE t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(respuestasexpediente);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query,
					RespuestasExpedienteDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds rows in the RespuestasExpediente table using like.
	 *
	 * @param respuestasexpediente
	 *            RespuestasExpediente
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RespuestasExpediente>
	 */
	@Override
	@Transactional(readOnly = true)
	public List<RespuestasExpediente> findAllLike(RespuestasExpediente respuestasexpediente,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_RESPUESTA_EXPEDIENTE IDRESPUESTAEXPEDIENTE, t1.ID_PREGUNTA_EXPEDIENTE IDPREGUNTAEXPEDIENTE,t1.RESPUESTA RESPUESTA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION, t1.NOTAS_INSPECTOR_CAS OBSERVACIONESINSPECCIONCAS, t1.NOTAS_INSPECTOR_EUS OBSERVACIONESINSPECCIONEUS ");
		query.append("FROM RESPUESTAS_EXPEDIENTE t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(respuestasexpediente, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query,
					RespuestasExpedienteDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the RespuestasExpediente table.
	 *
	 * @param respuestasexpediente
	 *            RespuestasExpediente
	 * @return Long
	 */
	@Override
	@Transactional(readOnly = true)
	public Long findAllCount(RespuestasExpediente respuestasexpediente) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM RESPUESTAS_EXPEDIENTE t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(respuestasexpediente);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the RespuestasExpediente table using like.
	 *
	 * @param respuestasexpediente
	 *            RespuestasExpediente
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Override
	@Transactional(readOnly = true)
	public Long findAllLikeCount(RespuestasExpediente respuestasexpediente, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM RESPUESTAS_EXPEDIENTE t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(respuestasexpediente, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of RespuestasExpediente selected for rup_table
	 *
	 * @param respuestasexpediente
	 *            RespuestasExpediente
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RespuestasExpediente>>
	 */
	@Override
	public List<TableRowDto<RespuestasExpediente>> reorderSelection(RespuestasExpediente respuestasexpediente,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_RESPUESTA_EXPEDIENTE IDRESPUESTAEXPEDIENTE,t1.ID_PREGUNTA_EXPEDIENTE IDPREGUNTAEXPEDIENTE,t1.RESPUESTA RESPUESTA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		// FROM
		query.append("FROM RESPUESTAS_EXPEDIENTE t1 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(respuestasexpediente, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto,
				RespuestasExpediente.class, filterParamList, "ID_RESPUESTA_EXPEDIENTE");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<RespuestasExpediente>(this.rwMapPK, tableRequestDto),
				filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            RespuestasExpediente
	 * @param searchParams
	 *            RespuestasExpediente
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RespuestasExpediente>>
	 */
	@Override
	public List<TableRowDto<RespuestasExpediente>> search(RespuestasExpediente filterParams,
			RespuestasExpediente searchParams, TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_RESPUESTA_EXPEDIENTE IDRESPUESTAEXPEDIENTE,t1.ID_PREGUNTA_EXPEDIENTE IDPREGUNTAEXPEDIENTE,t1.RESPUESTA RESPUESTA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		// FROM
		query.append("FROM RESPUESTAS_EXPEDIENTE t1 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = TableManager.getSearchQuery(query, tableRequestDto,
				RespuestasExpediente.class, filterParamList, searchSQL, searchParamList, from_alias,
				"ID_RESPUESTA_EXPEDIENTE");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<RespuestasExpediente>(this.rwMapPK, tableRequestDto),
				filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filterrespuestasexpediente
	 *            RespuestasExpediente
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(RespuestasExpediente filterrespuestasexpediente, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		// SELECT
		/** TODO: select por clave */
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_RESPUESTA_EXPEDIENTE IDRESPUESTAEXPEDIENTE,t1.ID_PREGUNTA_EXPEDIENTE IDPREGUNTAEXPEDIENTE,t1.RESPUESTA RESPUESTA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		// FROM
		query.append("FROM RESPUESTAS_EXPEDIENTE t1 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterrespuestasexpediente, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = TableManager.getRemoveMultipleQuery(tableRequestDto,
				RespuestasExpediente.class, query, params, "ID_RESPUESTA_EXPEDIENTE");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Filter in the hierarchical RespuestasExpediente table.
	 *
	 * @param filterRespuestasExpediente
	 *            RespuestasExpediente
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<JerarquiaDto<RespuestasExpediente>>
	 */
	@Override
	public List<JerarquiaDto<RespuestasExpediente>> findAllLikeJerarquia(
			RespuestasExpediente filterRespuestasExpediente, TableRequestDto tableRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_RESPUESTA_EXPEDIENTE IDRESPUESTAEXPEDIENTE, t1.ID_PREGUNTA_EXPEDIENTE IDPREGUNTAEXPEDIENTE,t1.RESPUESTA RESPUESTA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION,t1.NOTAS_INSPECTOR_CAS OBSERVACIONESINSPECCIONCAS, t1.NOTAS_INSPECTOR_EUS OBSERVACIONESINSPECCIONEUS ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM RESPUESTAS_EXPEDIENTE t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("RESPUESTAS_EXPEDIENTE");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterRespuestasExpediente, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = TableManagerJerarquia.getQuery(tableRequestDto, query, mapaWhere, "ID_RESPUESTA_EXPEDIENTE", "ID_PADRE",
				"NOMBRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = TableManagerJerarquia.getQuery(tableRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		if (tableRequestDto != null) {
			query = TableManagerJerarquia.getPaginationQuery(tableRequestDto, query,
					RespuestasExpedienteDaoImpl.ORDER_BY_WHITE_LIST);
		}

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterRespuestasExpediente
	 *            RespuestasExpediente
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	@Override
	public Long findAllLikeCountJerarquia(RespuestasExpediente filterRespuestasExpediente,
			TableRequestDto tableRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM RESPUESTAS_EXPEDIENTE t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("RESPUESTAS_EXPEDIENTE");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterRespuestasExpediente, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID_RESPUESTA_EXPEDIENTE",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID",
		// "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterRespuestasExpediente
	 *            RespuestasExpediente
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<RespuestasExpediente>>
	 */
	@Override
	public List<TableRowDto<RespuestasExpediente>> findAllChild(RespuestasExpediente filterRespuestasExpediente,
			TableRequestDto tableRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM RESPUESTAS_EXPEDIENTE t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("RESPUESTAS_EXPEDIENTE");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterRespuestasExpediente, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
				"ID_RESPUESTA_EXPEDIENTE", "ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<RespuestasExpediente>(this.rwMapPK, "ID_RESPUESTA_EXPEDIENTE"),
				params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the RespuestasExpediente entity
	 *
	 * @param respuestasexpediente
	 *            RespuestasExpediente Bean with the criteria values to filter
	 *            by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(RespuestasExpediente respuestasexpediente) {

		StringBuilder where = new StringBuilder(RespuestasExpedienteDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (respuestasexpediente != null && respuestasexpediente.getIdRespuestaExpediente() != null) {
			where.append(" AND t1.ID_RESPUESTA_EXPEDIENTE = ?");
			params.add(respuestasexpediente.getIdRespuestaExpediente());
		}
		if (respuestasexpediente != null && respuestasexpediente.getPreguntaExpediente() != null
				&& respuestasexpediente.getPreguntaExpediente().getIdPreguntaExpediente() != null) {
			where.append(" AND t1.ID_PREGUNTA_EXPEDIENTE = ?");
			params.add(respuestasexpediente.getPreguntaExpediente().getIdPreguntaExpediente());
		}
		if (respuestasexpediente != null && respuestasexpediente.getRespuesta() != null) {
			where.append(" AND t1.RESPUESTA = ?");
			params.add(respuestasexpediente.getRespuesta());
		}
		if (respuestasexpediente != null && respuestasexpediente.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(respuestasexpediente.getFechaRegistro());
		}
		if (respuestasexpediente != null && respuestasexpediente.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(respuestasexpediente.getUsuarioRegistro());
		}
		if (respuestasexpediente != null && respuestasexpediente.getFechaUltmodificacion() != null) {
			where.append(" AND t1.FECHA_ULTMODIFICACION = ?");
			params.add(respuestasexpediente.getFechaUltmodificacion());
		}
		if (respuestasexpediente != null && respuestasexpediente.getUsuarioUltmodificacion() != null) {
			where.append(" AND t1.USUARIO_ULTMODIFICACION = ?");
			params.add(respuestasexpediente.getUsuarioUltmodificacion());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the RespuestasExpediente entity
	 *
	 * @param respuestasexpediente
	 *            RespuestasExpediente Bean with the criteria values to filter
	 *            by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(RespuestasExpediente respuestasexpediente, Boolean startsWith) {

		StringBuilder where = new StringBuilder(RespuestasExpedienteDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (respuestasexpediente != null && respuestasexpediente.getIdRespuestaExpediente() != null) {
			where.append(" AND t1.ID_RESPUESTA_EXPEDIENTE = ?");
			params.add(respuestasexpediente.getIdRespuestaExpediente());
		}
		if (respuestasexpediente != null && respuestasexpediente.getPreguntaExpediente() != null
				&& respuestasexpediente.getPreguntaExpediente().getIdPreguntaExpediente() != null) {
			where.append(" AND t1.ID_PREGUNTA_EXPEDIENTE = ?");
			params.add(respuestasexpediente.getPreguntaExpediente().getIdPreguntaExpediente());
		}
		if (respuestasexpediente != null && respuestasexpediente.getRespuesta() != null) {
			where.append(" AND UPPER(t1.RESPUESTA) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(respuestasexpediente.getRespuesta().toUpperCase() + "%");
			} else {
				params.add("%" + respuestasexpediente.getRespuesta().toUpperCase() + "%");
			}
			where.append(" AND t1.RESPUESTA IS NOT NULL");
		}
		if (respuestasexpediente != null && respuestasexpediente.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(respuestasexpediente.getFechaRegistro());
		}
		if (respuestasexpediente != null && respuestasexpediente.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(respuestasexpediente.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + respuestasexpediente.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}
		if (respuestasexpediente != null && respuestasexpediente.getFechaUltmodificacion() != null) {
			where.append(" AND t1.FECHA_ULTMODIFICACION = ?");
			params.add(respuestasexpediente.getFechaUltmodificacion());
		}
		if (respuestasexpediente != null && respuestasexpediente.getUsuarioUltmodificacion() != null) {
			where.append(" AND UPPER(t1.USUARIO_ULTMODIFICACION) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(respuestasexpediente.getUsuarioUltmodificacion().toUpperCase() + "%");
			} else {
				params.add("%" + respuestasexpediente.getUsuarioUltmodificacion().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_ULTMODIFICACION IS NOT NULL");
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;

}
